Index: tests/modeltests/select_related/models.py
===================================================================
--- tests/modeltests/select_related/models.py	(revision 6799)
+++ tests/modeltests/select_related/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-40. Tests for select_related()
+Tests for select_related()
 
 ``select_related()`` follows all relationships and pre-caches any foreign key
 values so that complex trees can be fetched in a single query. However, this
Index: tests/modeltests/basic/models.py
===================================================================
--- tests/modeltests/basic/models.py	(revision 6799)
+++ tests/modeltests/basic/models.py	(working copy)
@@ -1,6 +1,6 @@
 # coding: utf-8
 """
-1. Bare-bones model
+Bare-bones model
 
 This is a basic model with only two non-primary-key fields.
 """
Index: tests/modeltests/m2m_recursive/models.py
===================================================================
--- tests/modeltests/m2m_recursive/models.py	(revision 6799)
+++ tests/modeltests/m2m_recursive/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-28. Many-to-many relationships between the same two tables
+Many-to-many relationships between the same two tables
 
 In this example, A Person can have many friends, who are also people. Friendship is a
 symmetrical relationship - if I am your friend, you are my friend.
Index: tests/modeltests/one_to_one/models.py
===================================================================
--- tests/modeltests/one_to_one/models.py	(revision 6799)
+++ tests/modeltests/one_to_one/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-10. One-to-one relationships
+One-to-one relationships
 
 To define a one-to-one relationship, use ``OneToOneField()``.
 
Index: tests/modeltests/m2o_recursive/models.py
===================================================================
--- tests/modeltests/m2o_recursive/models.py	(revision 6799)
+++ tests/modeltests/m2o_recursive/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-11. Relating an object to itself, many-to-one
+Relating an object to itself, many-to-one
 
 To define a many-to-one relationship between a model and itself, use
 ``ForeignKey('self')``.
Index: tests/modeltests/custom_managers/models.py
===================================================================
--- tests/modeltests/custom_managers/models.py	(revision 6799)
+++ tests/modeltests/custom_managers/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-23. Giving models a custom manager
+Giving models a custom manager
 
 You can use a custom ``Manager`` in a particular model by extending the base
 ``Manager`` class and instantiating your custom ``Manager`` in your model.
Index: tests/modeltests/invalid_models/models.py
===================================================================
--- tests/modeltests/invalid_models/models.py	(revision 6799)
+++ tests/modeltests/invalid_models/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-26. Invalid models
+Invalid models
 
 This example exists purely to point out errors in models.
 """
Index: tests/modeltests/many_to_many/models.py
===================================================================
--- tests/modeltests/many_to_many/models.py	(revision 6799)
+++ tests/modeltests/many_to_many/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-5. Many-to-many relationships
+Many-to-many relationships
 
 To define a many-to-many relationship, use ManyToManyField().
 
Index: tests/modeltests/m2m_and_m2o/models.py
===================================================================
--- tests/modeltests/m2m_and_m2o/models.py	(revision 6799)
+++ tests/modeltests/m2m_and_m2o/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-29. Many-to-many and many-to-one relationships to the same table
+Many-to-many and many-to-one relationships to the same table
 
 Make sure to set ``related_name`` if you use relationships to the same table.
 """
Index: tests/modeltests/validation/models.py
===================================================================
--- tests/modeltests/validation/models.py	(revision 6799)
+++ tests/modeltests/validation/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-31. Validation
+Validation
 
 This is an experimental feature!
 
Index: tests/modeltests/or_lookups/models.py
===================================================================
--- tests/modeltests/or_lookups/models.py	(revision 6799)
+++ tests/modeltests/or_lookups/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-19. OR lookups
+OR lookups
 
 To perform an OR lookup, or a lookup that combines ANDs and ORs,
 combine QuerySet objects using & and | operators.
Index: tests/modeltests/mutually_referential/models.py
===================================================================
--- tests/modeltests/mutually_referential/models.py	(revision 6799)
+++ tests/modeltests/mutually_referential/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-24. Mutually referential many-to-one relationships
+Mutually referential many-to-one relationships
 
 To define a many-to-one relationship, use ``ForeignKey()`` .
 """
Index: tests/modeltests/custom_methods/models.py
===================================================================
--- tests/modeltests/custom_methods/models.py	(revision 6799)
+++ tests/modeltests/custom_methods/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-3. Giving models custom methods
+Giving models custom methods
 
 Any method you add to a model will be available to instances.
 """
Index: tests/modeltests/empty/models.py
===================================================================
--- tests/modeltests/empty/models.py	(revision 6799)
+++ tests/modeltests/empty/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-39. Empty model tests
+Empty model tests
 
 These test that things behave sensibly for the rare corner-case of a model with
 no fields.
Index: tests/modeltests/many_to_one_null/models.py
===================================================================
--- tests/modeltests/many_to_one_null/models.py	(revision 6799)
+++ tests/modeltests/many_to_one_null/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-16. Many-to-one relationships that can be null
+Many-to-one relationships that can be null
 
 To define a many-to-one relationship that can have a null foreign key, use
 ``ForeignKey()`` with ``null=True`` .
Index: tests/modeltests/get_or_create/models.py
===================================================================
--- tests/modeltests/get_or_create/models.py	(revision 6799)
+++ tests/modeltests/get_or_create/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-33. get_or_create()
+get_or_create()
 
 get_or_create() does what it says: it tries to look up an object with the given
 parameters. If an object isn't found, it creates one with the given parameters.
Index: tests/modeltests/custom_pk/models.py
===================================================================
--- tests/modeltests/custom_pk/models.py	(revision 6799)
+++ tests/modeltests/custom_pk/models.py	(working copy)
@@ -1,6 +1,6 @@
 # -*- coding: utf-8 -*-
 """
-14. Using a custom primary key
+Using a custom primary key
 
 By default, Django adds an ``"id"`` field to each model. But you can override
 this behavior by explicitly adding ``primary_key=True`` to a field.
Index: tests/modeltests/reverse_lookup/models.py
===================================================================
--- tests/modeltests/reverse_lookup/models.py	(revision 6799)
+++ tests/modeltests/reverse_lookup/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-25. Reverse lookups
+Reverse lookups
 
 This demonstrates the reverse lookup features of the database API.
 """
Index: tests/modeltests/m2o_recursive2/models.py
===================================================================
--- tests/modeltests/m2o_recursive2/models.py	(revision 6799)
+++ tests/modeltests/m2o_recursive2/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-12. Relating a model to another model more than once
+Relating a model to another model more than once
 
 In this example, a ``Person`` can have a ``mother`` and ``father`` -- both of
 which are other ``Person`` objects.
Index: tests/modeltests/m2m_multiple/models.py
===================================================================
--- tests/modeltests/m2m_multiple/models.py	(revision 6799)
+++ tests/modeltests/m2m_multiple/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-20. Multiple many-to-many relationships between the same two tables
+Multiple many-to-many relationships between the same two tables
 
 In this example, an Article can have many Categories (as "primary") and many
 Categories (as "secondary").
Index: tests/modeltests/m2m_intermediary/models.py
===================================================================
--- tests/modeltests/m2m_intermediary/models.py	(revision 6799)
+++ tests/modeltests/m2m_intermediary/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-9. Many-to-many relationships via an intermediary table
+Many-to-many relationships via an intermediary table
 
 For many-to-many relationships that need extra fields on the intermediary
 table, use an intermediary model.
Index: tests/modeltests/str/models.py
===================================================================
--- tests/modeltests/str/models.py	(revision 6799)
+++ tests/modeltests/str/models.py	(working copy)
@@ -1,6 +1,6 @@
 # -*- coding: utf-8 -*-
 """
-2. Adding __str__() or __unicode__() to models
+Adding __str__() or __unicode__() to models
 
 Although it's not a strict requirement, each model should have a
 ``_str__()`` or ``__unicode__()`` method to return a "human-readable"
Index: tests/modeltests/transactions/models.py
===================================================================
--- tests/modeltests/transactions/models.py	(revision 6799)
+++ tests/modeltests/transactions/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-15. Transactions
+Transactions
 
 Django handles transactions in three different ways. The default is to commit
 each transaction upon a write, but you can decorate a function to get
Index: tests/modeltests/model_inheritance/models.py
===================================================================
--- tests/modeltests/model_inheritance/models.py	(revision 6799)
+++ tests/modeltests/model_inheritance/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-XX. Model inheritance
+Model inheritance
 
 Model inheritance isn't yet supported.
 """
Index: tests/modeltests/lookup/models.py
===================================================================
--- tests/modeltests/lookup/models.py	(revision 6799)
+++ tests/modeltests/lookup/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-7. The lookup API
+The lookup API
 
 This demonstrates features of the database API.
 """
Index: tests/modeltests/choices/models.py
===================================================================
--- tests/modeltests/choices/models.py	(revision 6799)
+++ tests/modeltests/choices/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-21. Specifying 'choices' for a field
+Specifying 'choices' for a field
 
 Most fields take a ``choices`` parameter, which should be a tuple of tuples
 specifying which are the valid values for that field.
Index: tests/modeltests/save_delete_hooks/models.py
===================================================================
--- tests/modeltests/save_delete_hooks/models.py	(revision 6799)
+++ tests/modeltests/save_delete_hooks/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-13. Adding hooks before/after saving and deleting
+Adding hooks before/after saving and deleting
 
 To execute arbitrary code around ``save()`` and ``delete()``, just subclass
 the methods.
Index: tests/modeltests/pagination/models.py
===================================================================
--- tests/modeltests/pagination/models.py	(revision 6799)
+++ tests/modeltests/pagination/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-30. Object pagination
+Object pagination
 
 Django provides a framework for paginating a list of objects in a few lines
 of code. This is often useful for dividing search results or long lists of
Index: tests/modeltests/get_latest/models.py
===================================================================
--- tests/modeltests/get_latest/models.py	(revision 6799)
+++ tests/modeltests/get_latest/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-8. get_latest_by
+get_latest_by
 
 Models can have a ``get_latest_by`` attribute, which should be set to the name
 of a DateField or DateTimeField. If ``get_latest_by`` exists, the model's
Index: tests/modeltests/generic_relations/models.py
===================================================================
--- tests/modeltests/generic_relations/models.py	(revision 6799)
+++ tests/modeltests/generic_relations/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-34. Generic relations
+Generic relations
 
 Generic relations let an object have a foreign key to any object through a
 content-type/object-id field. A generic foreign key can point to any object,
Index: tests/modeltests/get_object_or_404/models.py
===================================================================
--- tests/modeltests/get_object_or_404/models.py	(revision 6799)
+++ tests/modeltests/get_object_or_404/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-35. DB-API Shortcuts
+DB-API Shortcuts
 
 get_object_or_404 is a shortcut function to be used in view functions for
 performing a get() lookup and raising a Http404 exception if a DoesNotExist
Index: tests/modeltests/properties/models.py
===================================================================
--- tests/modeltests/properties/models.py	(revision 6799)
+++ tests/modeltests/properties/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-22. Using properties on models
+Using properties on models
 
 Use properties on models just like on any other Python object.
 """
Index: tests/modeltests/serializers/models.py
===================================================================
--- tests/modeltests/serializers/models.py	(revision 6799)
+++ tests/modeltests/serializers/models.py	(working copy)
@@ -1,6 +1,6 @@
 # -*- coding: utf-8 -*-
 """
-41. Serialization
+Serialization
 
 ``django.core.serializers`` provides interfaces to converting Django querysets
 to and from "flat" data (i.e. strings).
Index: tests/modeltests/user_commands/models.py
===================================================================
--- tests/modeltests/user_commands/models.py	(revision 6799)
+++ tests/modeltests/user_commands/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-37. User-registered management commands
+User-registered management commands
 
 The manage.py utility provides a number of useful commands for managing a
 Django project. If you want to add a utility command of your own, you can.
Index: tests/modeltests/reserved_names/models.py
===================================================================
--- tests/modeltests/reserved_names/models.py	(revision 6799)
+++ tests/modeltests/reserved_names/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-18. Using SQL reserved names
+Using SQL reserved names
 
 Need to use a reserved SQL name as a column name or table name? Need to include
 a hyphen in a column or table name? No problem. Django quotes names
Index: tests/modeltests/model_forms/models.py
===================================================================
--- tests/modeltests/model_forms/models.py	(revision 6799)
+++ tests/modeltests/model_forms/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-36. Generating HTML forms from models
+Generating HTML forms from models
 
 Django provides shortcuts for creating Form objects from a model class and a
 model instance.
Index: tests/modeltests/many_to_one/models.py
===================================================================
--- tests/modeltests/many_to_one/models.py	(revision 6799)
+++ tests/modeltests/many_to_one/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-4. Many-to-one relationships
+Many-to-one relationships
 
 To define a many-to-one relationship, use ``ForeignKey()`` .
 """
Index: tests/modeltests/fixtures/models.py
===================================================================
--- tests/modeltests/fixtures/models.py	(revision 6799)
+++ tests/modeltests/fixtures/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-37. Fixtures.
+Fixtures.
 
 Fixtures are a way of loading data into the database in bulk. Fixure data
 can be stored in any serializable format (including JSON and XML). Fixtures
Index: tests/modeltests/ordering/models.py
===================================================================
--- tests/modeltests/ordering/models.py	(revision 6799)
+++ tests/modeltests/ordering/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-6. Specifying ordering
+Specifying ordering
 
 Specify default ordering for a model using the ``ordering`` attribute, which
 should be a list or tuple of field names. This tells Django how to order the
Index: tests/modeltests/custom_columns/models.py
===================================================================
--- tests/modeltests/custom_columns/models.py	(revision 6799)
+++ tests/modeltests/custom_columns/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-17. Custom column/table names
+Custom column/table names
 
 If your database column name is different than your model attribute, use the
 ``db_column`` parameter. Note that you'll use the field's name, not its column
Index: tests/modeltests/field_defaults/models.py
===================================================================
--- tests/modeltests/field_defaults/models.py	(revision 6799)
+++ tests/modeltests/field_defaults/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-32. Callable defaults
+Callable defaults
 
 You can pass callable objects as the ``default`` parameter to a field. When
 the object is created without an explicit value passed in, Django will call
Index: tests/modeltests/test_client/models.py
===================================================================
--- tests/modeltests/test_client/models.py	(revision 6799)
+++ tests/modeltests/test_client/models.py	(working copy)
@@ -1,6 +1,6 @@
 # coding: utf-8
 """
-38. Testing using the Test Client
+Testing using the Test Client
 
 The test client is a class that can act like a simple
 browser for testing purposes.
Index: tests/modeltests/manipulators/models.py
===================================================================
--- tests/modeltests/manipulators/models.py	(revision 6799)
+++ tests/modeltests/manipulators/models.py	(working copy)
@@ -1,5 +1,5 @@
 """
-27. Default manipulators
+Default manipulators
 
 Each model gets an AddManipulator and ChangeManipulator by default.
 """