=== modified file 'django/contrib/admin/options.py'
--- django/contrib/admin/options.py	2007-11-15 19:57:01 +0000
+++ django/contrib/admin/options.py	2007-11-15 19:57:05 +0000
@@ -521,7 +521,7 @@
             inline_admin_formsets.append(inline_admin_formset)
 
         c = template.RequestContext(request, {
-            'title': _('Add %s') % uncapfirst(opts.verbose_name),
+            'title': capfirst(_('Add %s') % uncapfirst(opts.verbose_name)),
             'adminform': adminForm,
             'is_popup': request.REQUEST.has_key('_popup'),
             'media': media,
@@ -596,7 +596,7 @@
             inline_admin_formsets.append(inline_admin_formset)
 
         c = template.RequestContext(request, {
-            'title': _('Change %s') % uncapfirst(opts.verbose_name),
+            'title': capfirst(_('Change %s') % uncapfirst(opts.verbose_name)),
             'adminform': adminForm,
             'object_id': object_id,
             'original': obj,

=== modified file 'django/contrib/admin/templates/admin/change_list.html'
--- django/contrib/admin/templates/admin/change_list.html	2007-11-13 02:16:19 +0000
+++ django/contrib/admin/templates/admin/change_list.html	2007-11-13 02:18:54 +0000
@@ -15,7 +15,7 @@
 <div id="content-main">
 {% block object-tools %}
 {% if has_add_permission %}
-<ul class="object-tools"><li><a href="add/{% if is_popup %}?_popup=1{% endif %}" class="addlink">{% blocktrans with cl.opts.verbose_name|uncapfirst|escape as name %}Add {{ name }}{% endblocktrans %}</a></li></ul>
+<ul class="object-tools"><li><a href="add/{% if is_popup %}?_popup=1{% endif %}" class="addlink">{% filter capfirst %}{% blocktrans with cl.opts.verbose_name|uncapfirst|escape as name %}Add {{ name }}{% endblocktrans %}{% endfilter %}</a></li></ul>
 {% endif %}
 {% endblock %}
 <div class="module{% if cl.has_filters %} filtered{% endif %}" id="changelist">

=== modified file 'django/contrib/admin/templates/admin/pagination.html'
--- django/contrib/admin/templates/admin/pagination.html	2007-11-13 02:16:19 +0000
+++ django/contrib/admin/templates/admin/pagination.html	2007-11-13 02:18:54 +0000
@@ -7,9 +7,9 @@
 {% endfor %}
 {% endif %}
 {% ifequal cl.result_count 1 %}
-	{% blocktrans with cl.result_count as count and cl.opts.verbose_name|uncapfirst|escape as verbose_name %}{{ count }} {{ verbose_name }}{% endblocktrans %}
+	{% filter capfirst %}{% blocktrans with cl.result_count as count and cl.opts.verbose_name|uncapfirst|escape as verbose_name %}{{ count }} {{ verbose_name }}{% endblocktrans %}{% endfilter %}
 {% else %}
-	{% blocktrans with cl.result_count as count and cl.opts.verbose_name_plural|uncapfirst|escape as verbose_name_plural %}{{ count }} {{ verbose_name_plural }}{% endblocktrans %}
+	{% filter capfirst %}{% blocktrans with cl.result_count as count and cl.opts.verbose_name_plural|uncapfirst|escape as verbose_name_plural %}{{ count }} {{ verbose_name_plural }}{% endblocktrans %}{% endfilter %}
 {% endifequal %}
 {% if show_all_url %}&nbsp;&nbsp;<a href="{{ show_all_url }}" class="showall">{% trans 'Show all' %}</a>{% endif %}
 </p>

=== modified file 'django/contrib/admin/views/main.py'
--- django/contrib/admin/views/main.py	2007-11-13 02:16:19 +0000
+++ django/contrib/admin/views/main.py	2007-11-13 02:18:54 +0000
@@ -9,7 +9,7 @@
 from django.db.models.query import handle_legacy_orderlist, QuerySet
 from django.http import Http404
 from django.utils.encoding import force_unicode, smart_str
-from django.utils.text import uncapfirst
+from django.utils.text import capfirst, uncapfirst
 from django.utils.translation import ugettext
 import operator
 
@@ -147,7 +147,7 @@
         self.query = request.GET.get(SEARCH_VAR, '')
         self.query_set = self.get_query_set()
         self.get_results(request)
-        self.title = (self.is_popup and ugettext('Select %s') % force_unicode(uncapfirst(self.opts.verbose_name)) or ugettext('Select %s to change') % force_unicode(uncapfirst(self.opts.verbose_name)))
+        self.title = capfirst((self.is_popup and ugettext('Select %s') % force_unicode(uncapfirst(self.opts.verbose_name)) or ugettext('Select %s to change') % force_unicode(uncapfirst(self.opts.verbose_name))))
         self.filter_specs, self.has_filters = self.get_filters(request)
         self.pk_attname = self.lookup_opts.pk.attname
 