Index: django/contrib/localflavor/uk/uk_counties.py
===================================================================
--- django/contrib/localflavor/uk/uk_counties.py	(revision 0)
+++ django/contrib/localflavor/uk/uk_counties.py	(revision 0)
@@ -0,0 +1,112 @@
+"""
+Source: http://www.statistics.gov.uk/geography/downloads/31_10_01_County_names_and_codes_12_00.xls
+"""
+
+ENGLAND_COUNTY_CHOICES = (
+    ("Greater London", "Greater London"),
+    ("Greater Manchester", "Greater Manchester"),
+    ("Merseyside", "Merseyside"),
+    ("South Yorkshire", "South Yorkshire"),
+    ("Tyne and Wear", "Tyne and Wear"),
+    ("West Midlands", "West Midlands"),
+    ("West Yorkshire", "West Yorkshire"),
+    ("Bedfordshire", "Bedfordshire"),
+    ("Buckinghamshire", "Buckinghamshire"),
+    ("Cambridgeshire", "Cambridgeshire"),
+    ("Cheshire", "Cheshire"),
+    ("Cornwall and Isles of Scilly", "Cornwall and Isles of Scilly"),
+    ("Cumbria", "Cumbria"),
+    ("Derbyshire", "Derbyshire"),
+    ("Devon", "Devon"),
+    ("Dorset", "Dorset"),
+    ("Durham", "Durham"),
+    ("East Sussex", "East Sussex"),
+    ("Essex", "Essex"),
+    ("Gloucestershire", "Gloucestershire"),
+    ("Hampshire", "Hampshire"),
+    ("Hertfordshire", "Hertfordshire"),
+    ("Kent", "Kent"),
+    ("Lancashire", "Lancashire"),
+    ("Leicestershire", "Leicestershire"),
+    ("Lincolnshire", "Lincolnshire"),
+    ("Norfolk", "Norfolk"),
+    ("Northamptonshire", "Northamptonshire"),
+    ("Northumberland", "Northumberland"),
+    ("North Yorkshire", "North Yorkshire"),
+    ("Nottinghamshire", "Nottinghamshire"),
+    ("Oxfordshire", "Oxfordshire"),
+    ("Shropshire", "Shropshire"),
+    ("Somerset", "Somerset"),
+    ("Staffordshire", "Staffordshire"),
+    ("Suffolk", "Suffolk"),
+    ("Surrey", "Surrey"),
+    ("Warwickshire", "Warwickshire"),
+    ("West Sussex", "West Sussex"),
+    ("Wiltshire", "Wiltshire"),
+    ("Worcestershire", "Worcestershire"),
+)
+
+"""
+Source: http://en.wikipedia.org/wiki/List_of_Irish_counties_by_area
+"""
+NORTHERN_IRELAND_COUNTY_CHOICES = (
+    ("County Antrim", "County Antrim"),
+    ("County Armagh", "County Armagh"),
+    ("County Down", "County Down"),
+    ("County Fermanagh", "County Down"),
+    ("County Londonderry", "County Londonderry"),
+    ("County Tyrone", "County Tyrone"),
+)
+
+"""
+Source: http://en.wikipedia.org/wiki/Preserved_counties_of_Wales
+"""
+WALES_COUNTY_CHOICES = (
+    ("Gwent", "Gwent"),
+    ("South Glamorgan", "South Glamorgan"),
+    ("Mid Glamorgan", "Mid Glamorgan"),
+    ("West Glamorgan", "West Glamorgan"),
+    ("Dyfed", "Dyfed"),
+    ("Powys", "Powys"),
+    ("Gwynedd", "Gwynedd"),
+    ("Clwyd", "Clwyd"),
+)
+"""
+Source: http://www.geo.ed.ac.uk/home/scotland/county3.html
+"""
+SCOTTISH_COUNTY_CHOICES = (
+    ("Aberdeen City", "Aberdeen City"),
+    ("Aberdeenshire", "Aberdeenshire"),
+    ("Angus", "Angus"),
+    ("Argyll and Bute", "Argyll and Bute"),
+    ("Clackmannan", "Clackmannan"),
+    ("Dumbarton and Clydebank", "Dumbarton and Clydebank"),
+    ("Dumfries and Galloway", "Dumfries and Galloway"),
+    ("Dundee (City of)", "Dundee (City of)"),
+    ("East Ayrshire", "East Ayrshire"),
+    ("East Dunbartonshire", "East Dunbartonshire"),
+    ("East Lothian", "East Lothian"),
+    ("East Renfrewshire", "East Renfrewshire"),
+    ("Edinburgh (City of)", "Edinburgh (City of)"),
+    ("Falkirk", "Falkirk"),
+    ("Fife", "Fife"),
+    ("Glasgow (City of)", "Glasgow (City of)"),
+    ("Highland", "Highland"), 
+    ("Inverclyde", "Inverclyde"),
+    ("Midlothian", "Midlothian"),
+    ("Moray", "Moray"),
+    ("North Ayrshire", "North Ayrshire"),
+    ("North Lanarkshire", "North Lanarkshire"),
+    ("Perthshire and Kinross", "Perthshire and Kinross"),
+    ("Renfrewshire", "Renfrewshire"),
+    ("Scottish Borders", "Scottish Borders"),
+    ("South Ayrshire", "South Ayrshire"),
+    ("South Lanarkshire", "South Lanarkshire"),
+    ("Stirling", "Stirling"),
+    ("West Lothian", "West Lothian"),
+    ("Orkney", "Orkney"),
+    ("Shetland", "Shetland"),
+    ("Western Isles", "Western Isles"), 
+)
+
+UK_COUNTY_CHOICES = ENGLAND_COUNTY_CHOICES + NORTHERN_IRELAND_COUNTY_CHOICES + WALES_COUNTY_CHOICES + SCOTTISH_COUNTY_CHOICES
\ No newline at end of file